<template>
    <div :class="{'hidden':hidden}" class="pagination-container">
        <el-pagination
            :background="background"
            :current-page.sync="currentPage"
            :page-size.sync="currentSizes"
            :layout="layout"
            :page-sizes="sizes"
            :total="total"
            v-bind="$attrs"
            @size-change="handleSizeChange"
            @current-change="handleCurrentChange"
        />
    </div>
</template>

<script>

import { scrollTo } from '@/utils/scroll-to';

export default {
    name: 'Pagination',
    props: {
        total: {
            required: true,
            type: Number
        },
        page: {
            type: Number,
            default: 1
        },
        perpage: {
            type: Number,
            default: 25
        },
        sizes: {
            type: Array,
            default() {
                return [25, 50, 100]
            }
        },
        layout: {
            type: String,
            default: 'total, sizes, prev, pager, next, jumper'
        },
        background: {
            type: Boolean,
            default: true
        },
        autoScroll: {
            type: Boolean,
            default: true
        },
        hidden: {
            type: Boolean,
            default: false
        }
    },
    computed: {
        currentPage: {
            get(){
                return this.page;
            },
            set(val){
                this.$emit('update:page', val);
            }
        },
        currentSizes: {
            get(){
                return this.perpage;
            },
            set(val){
                this.$emit('update:perpage', val);
            }
        }
    },
    methods: {
        handleSizeChange(val){
            this.$emit('pagination', {
                page: this.currentPage,
                perpage: val
            });
            if(this.autoScroll){
                scrollTo(0, 800);
            }
        },
        handleCurrentChange(val){
            this.$emit('pagination', {
                page: val,
                perpage: this.sizes
            });
            if(this.autoScroll){
                scrollTo(0, 800);
            }
        }
    }
}
</script>
<style scoped>
    .pagination-container {
        background: #fff;
        padding: 32px 16px;
    }
    .pagination-container.hidden {
        display: none;
    }
</style>